//+------------------------------------------------------------------+
//|                                       ButNakedbarTrading-exp.mq4 |
//|                                  Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>
#include <WinUser32.mqh>

extern int MagicNumber = 1867;

extern int EquityGainPercent = 1;

extern int TakeProfit1=0;
extern int BreakEven=6;
extern int StopLoss=200;  
extern int  OrderPipsDiff=5;

extern bool InsideBar=true;
extern bool OutSideBar=true;

extern bool KeyReversalBar=true;
extern int  KeyReversalOpenDiff=10;

extern bool TwoBarReversal=true;
extern int  Open1Close2WithinPrevHLPips=3;
extern int  Open2WithinPrevClosePips=20;
extern int  BodyPips=10;
extern int  PipsFromMid=10;

extern int CancelOrderBars=4;

extern double Lots = 0.1;  
extern double MaximumRisk = 5;
extern int    LotDigits = 1;  
extern bool   FixedLot = true;

extern int    slippage=2;   	//slippage for market order 
int    shift=1;			//shift to current bar, 

extern int    OrderTriesNumber=2; //to repeate sending orders when got some error

extern string    EAName="bblo"; 

bool buysig,sellsig,closebuy,closesell,remorder,tickvalue;
int lastsig,last,tries,co,mkt;

int init()
  {

//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
//----
  }




void start()  {


   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   co=CalculateCurrentOrders(Symbol());

   CheckForSignals();
   if (co>0) CheckForClose();
   CheckForOpen();
   
   co=CalculateCurrentOrders(Symbol());

   if (mkt>0) {
      BreakEvenStop(BreakEven,0);
     
      
      double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
Print("Account equity = ",AccountEquity());
Print("Account balance = ",AccountBalance());

 if(pcnt>EquityGainPercent)
 { 
int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
    }  
  }
  
 
     Print("ALL ORDERS CLOSE-->Locked in on Profits");
 }
 return(0);

  }
   }
       



//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int ord; mkt=0;
//----
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==symbol && OrderMagicNumber()==MagicNumber) {
         ord++;
         if (OrderType()==OP_BUY || OrderType()==OP_SELL) mkt++;
      }
   }
//---- return orders volume
   return(ord);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {
      //check long,short,exit signals
      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;
      remorder=false;
      

      int isins,isouts,iskeyrev,is2brev;
      if (InsideBar) isins=IsInsideBar(shift);
      if (OutSideBar) isouts=IsOutSideBar(shift);
      if (KeyReversalBar) iskeyrev=IsKeyReversalBar(shift);
      if (TwoBarReversal) is2brev=IsTwoBarReversal(shift);

      //long entry signal condition
      if (isins>0 || isouts>0 || iskeyrev>0 || is2brev>0) {
         buysig=true;
         closesell=true;
      }
      //short entry signal
      if (isins<0 || isouts<0 || iskeyrev<0 || is2brev<0) {
         buysig=false;
         sellsig=true;
         closebuy=true;
      }

      if (last>0 && (Time[0]-last)/(Period()*60)>=CancelOrderBars) {
         remorder=true;
      }

}

void CheckForOpen() {
   int    res,tr;
//---- sell conditions
   co=CalculateCurrentOrders(Symbol());
   if(sellsig && lastsig!=-1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
        res = OpenStop(OP_SELLSTOP,LotsRisk(StopLoss), Low[shift]-OrderPipsDiff*Point, StopLoss, TakeProfit1);

        }
	   lastsig=-1;
	   last=Time[0];
      return;
   }
//---- buy conditions
   if(buysig && lastsig!=1)  {
      co=CalculateCurrentOrders(Symbol());
	   if (co==0) {
        res = OpenStop(OP_BUYSTOP,LotsRisk(StopLoss), High[shift]+OrderPipsDiff*Point, StopLoss, TakeProfit1);

        }
	   last=Time[0];
	   lastsig=1;
      return;
   }
}
  


void BreakEvenStop(int BES, int BELP) {
   //move stoploss to lock some profit
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}


int IsInsideBar(int shift) {
   //Inside Bar, The close of the inside bar should be higher than both the close and the bar midpoint The current bar must open 
   //equal or higher than the close of the inside bar a BuyStop order is to be placed at the high of the inside bar if the order 
   //is not hit within the next 4 bars cancel order. See picture below
   if (High[shift]>High[shift+1]) return(0);
   if (Low[shift]<Low[shift+1]) return(0);
   if (Close[shift]>Open[shift] && Close[shift]>(High[shift]+Low[shift])/2 && Open[shift-1]>=Close[shift]) return(1);
   if (Close[shift]<Open[shift] && Close[shift]<(High[shift]+Low[shift])/2 && Open[shift-1]<=Close[shift]) return(-1);
   return(false);
}

int IsOutSideBar(int shift) {
   //Outside Bar, The close of the outside bar should be higher than the open and higher that the bar midpoint the open 
   //of the current bar should open equal or higher than the close of the outside bar order A Buystop order should be 
   //placed on the high of the outside bar if it is not executed within the next 4 bars cancel order. See picture below
   if (High[shift]<High[shift+1]) return(0);
   if (Low[shift]>Low[shift+1]) return(0);
   if (Close[shift]>Open[shift] && Close[shift]>(High[shift]+Low[shift])/2 && Open[shift-1]>=Close[shift]) return(1);
   if (Close[shift]<Open[shift] && Close[shift]<(High[shift]+Low[shift])/2 && Open[shift-1]<=Close[shift]) return(-1);
   return(false);
}

int IsKeyReversalBar(int shift) {
   //Key Reversal Bar, The open of the key bar should be at least ?pips higher than the high of the previous bar. 
   //The close of the key bar should be with in the high and close of the previous bar. The open of the current bar should be 
   //lower than the close of the key bar. A SellStop order should be place on the low of the key bar if it is not executed within 
   //the next 4 bars then cancel the order. See picture below - short!
   if (Open[shift]<Low[shift+1] && Close[shift]>=Low[shift+1]  && Close[shift]<=Close[shift+1] && Open[shift-1]>Close[shift]) return(1);
   if (Open[shift]>High[shift+1] && Close[shift]<=High[shift+1]  && Close[shift]>=Close[shift+1] && Open[shift-1]<Close[shift]) return(-1);
   return(0);
}


int IsTwoBarReversal(int shift) {
   //Two Bar Reversal, The open of the first bar should be near the low the previous bar and the close should be much lower and 
   //have a good size body. The open of the second bar should be very near the close of the first bar but both should be well below 
   //the midpoint of each bar with the close to be very near the low 2 bar previous. A BuyStop Order should be place at the high of
   //the bar 1 if it is not executed within 4 bars cancel order. See picture below
   if (MathAbs(Open[shift+1]-Close[shift+1])> MathAbs(Open[shift+1]-Low[shift+2])<= 
       MathAbs(Close[shift]-Low[shift+2])<=
       MathAbs(Open[shift]-Close[shift+1]) &&
       Close[shift+1]<(High[shift+1]+Low[shift+1])/2 &&
       Open[shift]<(High[shift]+Low[shift])/2)
         return(1);
   if (MathAbs(Open[shift+1]-Close[shift+1])> MathAbs(Open[shift+1]-High[shift+2])<= 
       MathAbs(Close[shift]-Low[shift+2])<= 
       MathAbs(Open[shift]-Close[shift+1]) &&
       Close[shift+1]>(High[shift+1]+Low[shift+1])/2 &&
       Open[shift]>(High[shift]+Low[shift])/2)
         return(-1);
   return(0);
}

int OpenStop(int mode,double lot, double prc, int SL, int TP) {
   int    res,tr,col;
   string mail;
   double openprice,sl,tp,stlev;
   tries=0;
   stlev=(1+MarketInfo(Symbol(),MODE_STOPLEVEL))*Point;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELLSTOP) {
         if (prc<=Bid-stlev) openprice=prc; 
         else openprice=Bid-stlev; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
         col=Red;
      } else
      if (mode==OP_BUYSTOP) {
         if (prc>=Ask+stlev) openprice=prc; 
         else openprice=Ask+stlev; 
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
         col=Blue;
      } else return;
      Print(Ask," ",Bid," ",Symbol(),"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ");
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+"_"+MagicNumber,MagicNumber,0,col);
      tries++;
   }
   if (res<=0) Print("Error opening pending order : ",ErrorDescription(GetLastError()));
   return(res);
}

void CheckForClose()  {
   bool bres; int tr;
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!=MagicNumber || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && closebuy) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_SELL && closesell) {
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_BUYSTOP && (closebuy || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
      if(OrderType()==OP_SELLSTOP && (closesell || remorder)) {
         bres=DeletePending(OrderTicket());
         continue;
      }
   }
}

bool DeletePending(int ticket) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      bres=OrderDelete(ticket);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error deleting order : ",ErrorDescription(GetLastError()));
   return (bres);
}

bool CloseAtMarket(int ticket,double lot) {
   //fault tolerant market order closing
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      tries++;
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
   }
   if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
}


double LotsRisk(int StopLoss)  { 
   double lot=Lots;
   int SL=StopLoss;
   if (SL==0) SL=100;
//---- select lot size
   if (!FixedLot)
      lot=AccountFreeMargin()*MaximumRisk*0.001/SL;
   lot=NormalizeDouble(lot,LotDigits);
//---- return lot size
   if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   return(lot);
}


      
   


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int Magic_Number, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "AUDCAD")       isymbol = 1;
   else if (symbol == "AUDCHF")  isymbol = 2;
   else if (symbol == "AUDJPY")  isymbol = 3;
   else if (symbol == "AUDDKK")  isymbol = 4;
   else if (symbol == "AUDNZD")  isymbol = 5;
   else if (symbol == "AUDPLN")  isymbol = 6;
   else if (symbol == "AUDSGD")  isymbol = 7;
   else if (symbol == "AUDUSD")  isymbol = 8;
   else if (symbol == "CADCHF")  isymbol = 9;
   else if (symbol == "CADJPY")  isymbol = 10;
   else if (symbol == "CHFCAD")  isymbol = 11;
   else if (symbol == "CHFJPY")  isymbol = 12;
   else if (symbol == "CHFSGD")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "EURCHF")  isymbol = 16;
   else if (symbol == "EURDKK")  isymbol = 17;
   else if (symbol == "EURGBP")  isymbol = 18;
   else if (symbol == "EURHKD")  isymbol = 19;
   else if (symbol == "EURHUF")  isymbol = 20;
   else if (symbol == "EURJPY")  isymbol = 21;
   else if (symbol == "EURLVL")  isymbol = 22;
   else if (symbol == "EURNOK")  isymbol = 23;
   else if (symbol == "EURNZD")  isymbol = 24;
   else if (symbol == "EURPLN")  isymbol = 25;
   else if (symbol == "EURSEK")  isymbol = 26;
   else if (symbol == "EURSGD")  isymbol = 27;
   else if (symbol == "EURSKK")  isymbol = 28;
   else if (symbol == "EURUSD")  isymbol = 29;
   else if (symbol == "EURZAR")  isymbol = 30;
   else if (symbol == "GBPAUD")  isymbol = 31;
   else if (symbol == "GBPCAD")  isymbol = 32;
   else if (symbol == "GBPCHF")  isymbol = 33;
   else if (symbol == "GBPDKK")  isymbol = 34;
   else if (symbol == "GBPJPY")  isymbol = 35;
   else if (symbol == "GBPNOK")  isymbol = 36;
   else if (symbol == "GBPNZD")  isymbol = 37;
   else if (symbol == "GBPSEK")  isymbol = 38;
   else if (symbol == "GBPSGD")  isymbol = 39;
   else if (symbol == "GBPUSD")  isymbol = 40;
   else if (symbol == "GBPZAR")  isymbol = 41;
   else if (symbol == "NZDCAD")  isymbol = 42;
   else if (symbol == "NZDCHF")  isymbol = 43;
   else if (symbol == "NZDJPY")  isymbol = 44;
   else if (symbol == "NZDSGD")  isymbol = 45;
   else if (symbol == "NZDUSD")  isymbol = 46;
   else if (symbol == "SGDJPY")  isymbol = 47;
   else if (symbol == "USDCAD")  isymbol = 48;
   else if (symbol == "USDCHF")  isymbol = 49;
   else if (symbol == "USDCCK")  isymbol = 50;
   else if (symbol == "USDDKK")  isymbol = 51;
   else if (symbol == "USDHKD")  isymbol = 52;
   else if (symbol == "USDHRK")  isymbol = 53;
   else if (symbol == "USDHUF")  isymbol = 54;
   else if (symbol == "USDJPY")  isymbol = 55;
   else if (symbol == "USDLVL")  isymbol = 56;
   else if (symbol == "USDLTL")  isymbol = 57;
   else if (symbol == "USDMXN")  isymbol = 58;
   else if (symbol == "USDNOK")  isymbol = 59;
   else if (symbol == "USDPLN")  isymbol = 60;
   else if (symbol == "USDSEK")  isymbol = 61;
   else if (symbol == "USDSGD")  isymbol = 62;
   else if (symbol == "USDSKK")  isymbol = 63;
   else if (symbol == "USDZAR")  isymbol = 64;
   else if (symbol == "#AA")  isymbol = 65;
   else if (symbol == "#AXP")  isymbol = 66;
   else if (symbol == "#BA")  isymbol = 67;
   else if (symbol == "#C")  isymbol = 68;
   else if (symbol == "#DD")  isymbol = 69;
   else if (symbol == "#DIS")  isymbol = 70;
   else if (symbol == "#AIG")  isymbol = 71;
   else if (symbol == "#GE")  isymbol = 72;
   else if (symbol == "#GM")  isymbol = 73;
   else if (symbol == "#HD")  isymbol = 74;
   else if (symbol == "#HON")  isymbol = 75;
   else if (symbol == "#HPQ")  isymbol = 76;
   else if (symbol == "#IBM")  isymbol = 77;
   else if (symbol == "#VZ")  isymbol = 78;
   else if (symbol == "#INTC")  isymbol = 79;
   else if (symbol == "#JNJ")  isymbol = 80;
   else if (symbol == "#JPM")  isymbol = 81;
   else if (symbol == "#KO")  isymbol = 82;
   else if (symbol == "#MCD")  isymbol = 83;
   else if (symbol == "#MMM")  isymbol = 84;
   else if (symbol == "#MO")  isymbol = 85;
   else if (symbol == "#MRK")  isymbol = 86;
   else if (symbol == "#MSFT")  isymbol = 87;
   else if (symbol == "#PG")  isymbol = 88;
   else if (symbol == "#T")  isymbol = 89;
   else if (symbol == "#PFE")  isymbol = 90;
   else if (symbol == "#UTX")  isymbol = 91;
   else if (symbol == "#WMT")  isymbol = 92;
   else if (symbol == "#XOM")  isymbol = 93;
   else if (symbol == "Gold")  isymbol = 94;
   else if (symbol == "Silver")  isymbol = 95;
   else if (symbol == "#EP")  isymbol = 96;
   else if (symbol == "#ENQ")  isymbol = 97;
   else if (symbol == "#YM")  isymbol = 98;
   else if (symbol == "#CL")  isymbol = 99;
   else if (symbol == "#NG")  isymbol = 100;
   else if (symbol == "#W")  isymbol = 101;
   else if (symbol == "#C")  isymbol = 102;
   else if (symbol == "#S")  isymbol = 103;
   else                          isymbol = 104;
   if(isymbol<10) Magic_Number = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}
//+------------------------------------------------------------------+